﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;
using System.Runtime.InteropServices;
using System.Globalization;


namespace NEW_MAP
{    
   
    public partial class Form1 : Form
    {   
        public int cutobjcount=0, 
                   obj12count=0, //количество семантических характеристик
                   crossobjcount = 0,
                   cutingobj = 0;
        public List<string> GetSemantName1 = new List<string>(), GetSemantName2 = new List<string>(), 
                            GetSemantValue1 = new List<string>(), GetSemantValue2 = new List<string>(), 
                            AddSemanticValue = new List<string>();
        public bool obj1, obj2;//флаги - если obj1, то у 1-го кол-во семантик больше, obj2 - у 2-го 

        public void CutObjectFunc(double ex, double ey)
        {
            if (cutobjcount == 1)
            {//выбираем объект для рассечения
             MapFind2.Active = false;
             MapFind2.FindPoint = true;
             // координаты и радиус поиска
             MapFind2.X = ex;
             MapFind2.Y = ey;
             MapFind2.Radius = 2;
             MapFind2.Active = true;
             MapObj2.StyleSelect = axGisToolKit.TxObjectStyleSelect.SEL_LINE;
             MapObj2.Style = axGisToolKit.TxObjectStyle.OS_SELECT;
             //проверяем был ли выбран объект и какой у него тип локализации
             if (MapObj2.Key==0 || MapObj2.Local!=
                                   axGisToolKit.TxObjectLocal.OL_SQUARE)
              {
                MessageBox.Show("Выберите площадной объект для рассечения!");
                MapObj2.Style = axGisToolKit.TxObjectStyle.OS_NORMAL;
                MapObj2.ObjHandle = 0;
               }
               cutobjcount = 1; }



            if (cutobjcount == 2)
            {//определяем структуру - описание объекта
             axGisToolKit.TxMapObjectInfo objinfo = new axGisToolKit.TxMapObjectInfo();
             //устанавливаем внешний код "служебный объект" и его тип - линейный 
                objinfo.ExCode = 1000000007;
                objinfo.Local = 00000000;
             //устанавливаем параметры описания объекта карты
                MapObj1.SetObjectByExcode((int)axGisToolKit.TxMetricType.IDFLOAT2,
                                                     objinfo.ExCode, objinfo.Local);
             //включаем режим создания рассекающей линии  
                MapEditMetric1.MetEditMode = axGisToolKit.TxEditMode.emCreate;
                MapEditMetric1.StartAction();
            }


            if (cutobjcount == 3)
            {   
            //строим рассечение замкнутого объекта по линии
            int hCross = EditMapObj.mapCreateObjectCutByLine(MapObj1.ObjHandle, 
                                                             MapObj2.ObjHandle, 1, 0); 
            //определяем порядковый номер рассекаемого объекта
            cutingobj =  EditMapObj.mapGetObjectNumber(MapObj2.ObjHandle);
            if (hCross > 0)
            {//пока не найдем все пересечения объектов
            while (EditMapObj.mapGetNextCut(hCross, MapObj2.ObjHandle) > 0)
              {
                //записываем пересечения как новые объекты
                 MapObj2.CommitAsNew();
              }
                //удаляем исходный рассекаемый объект
              EditMapObj.mapDeleteObjectByNumber(MapView1.MapHandle, 1, cutingobj);
                    MapObj2.Repaint();
                    MapView1.Repaint();
                    MapObj2.Style = axGisToolKit.TxObjectStyle.OS_NORMAL;
                    //удаляем рассекающий объект
                    MapObj1.Delete();
                    MapObj1.ObjHandle = 0;
                    NewObj = false;
                    CutObj.CheckState = CheckState.Unchecked;
                    cutobjcount = 0;
                }

                else 
                {//объект нельзя рассечь, прерываем операцию
                    MapObj2.Style = axGisToolKit.TxObjectStyle.OS_NORMAL;
                    MapObj1.Delete();
                    MapObj1.ObjHandle = 0;
                    NewObj = false;
                    CutObj.CheckState = CheckState.Unchecked;
                    cutobjcount = 0;
                
                }
            }
        }

        public void JoinObjectFunc(double ex, double ey)
        {   
            //устанавливаем допуск
            MapCross1.precision = percision;
            //определяем объекты для сшивки
             switch (crossobjcount)
            {case 0: MapFind1.Active = false;
                    MapFind1.FindPoint = true;
                    // координаты и радиус поиска
             MapFind1.X = ex; MapFind1.Y = ey;  MapFind1.Radius = 2;
                    MapFind1.Active = true;
                    //устанавливаем выделение
            MapObj1.StyleSelect = axGisToolKit.TxObjectStyleSelect.SEL_LINE;
            MapObj1.Style = axGisToolKit.TxObjectStyle.OS_SELECT;
                    //задаем 1-й объект для сшивки
                    MapCross1.cObjIn1 = MapObj1.C_CONTAINER;
                    crossobjcount++;
                    break;
              case 1: MapFind2.Active = false;
                    MapFind2.FindPoint = true;
                    // координаты и радиус поиска
             MapFind2.X = ex; MapFind2.Y = ey; MapFind2.Radius = 2;
                   MapFind2.Active = true;
            MapObj2.StyleSelect = axGisToolKit.TxObjectStyleSelect.SEL_LINE;
            MapObj2.Style = axGisToolKit.TxObjectStyle.OS_SELECT;
                    //задаем 2-й объект для сшивки
                    MapCross1.cObjIn2 = MapObj2.C_CONTAINER;
                  
                 
                   //определяем тип исходного объекта
                    if (MapObj1.Local.ToString() == "OL_SQUARE")
                        MapCross1.LocalOut = axGisToolKit.TxLOCALOUT.OUT_SQUARE;
                    else MapCross1.LocalOut = axGisToolKit.TxLOCALOUT.OUT_LINE;
                    //задаем куда сохранять результат сшивки
                    MapCross1.cObjOut = MapObj1.C_CONTAINER;
                  

                    //добавляем в списки имя семантики и ее значение для 1-го объекта
                    for (int j = 1; j <= MapObj1.Semantic.SemanticCount; j++)
                    {          
                      GetSemantName1.Add(MapObj1.Semantic.SemanticName_get(j));
                      GetSemantValue1.Add(MapObj1.Semantic.SemanticValue_get(j));
                    }
                    //добавляем в списки имя семантики и ее значение для 2-го объекта
                    for (int j = 1; j <= MapObj2.Semantic.SemanticCount; j++)
                    {
                      GetSemantName2.Add(MapObj2.Semantic.SemanticName_get(j));
                      GetSemantValue2.Add(MapObj2.Semantic.SemanticValue_get(j));
                    }

                    //определяем в каком объекте больше семантических характеристик
                    //и устанавливаем соответствующие флаги
                    if (MapObj1.Semantic.SemanticCount <= MapObj2.Semantic.SemanticCount)
                    {
                        obj12count = MapObj2.Semantic.SemanticCount;
                        obj2 = true;
                    }
                    else
                    {
                        obj12count = MapObj1.Semantic.SemanticCount;
                        obj1 = true;
                    }


                    //если в одно объекте есть семантические характеристики, а в другом они отсутствуют
                    //при объединении объектов добавляем их к семантикам результирующего объекта
                    if (MapObj1.Semantic.SemanticCount == 0 && MapObj2.Semantic.SemanticCount != 0)
                    {
                        for (int k = 0; k <= MapObj2.Semantic.SemanticCount - 1; k++)
                        {
                            AddSemanticCode.Add(MapView1.MapSemantics.SemanticCodeName_get(GetSemantName2[k]));
                            AddSemanticValue.Add(GetSemantValue2[k]);
                        }

                    }


                    //проходим по всем семантическим характеристикам двух объектов
                    for (int g = 0; g <= MapObj1.Semantic.SemanticCount - 1; g++)
                    {
                     for (int h = 0; h <= MapObj2.Semantic.SemanticCount - 1; h++)
                     {//проверяем равенство наименований и значений семантик объектов
                       if (GetSemantName1[g] == GetSemantName2[h]) {
                        if (GetSemantValue1[g] == GetSemantValue2[h]) {
                            obj12count--;
                            g++;
                      //при неравном количестве семантических характеристик 
                      // добавляем пустые строки для сравнения
                        if (g > MapObj1.Semantic.SemanticCount - 1)
                              GetSemantName1.Add(" ");
                        if (g > MapObj2.Semantic.SemanticCount - 1)
                              GetSemantName2.Add(" ");
                       } else {
                         //при несовпадении значений семантических характеристик
                    MessageBox.Show("Сшивка невозможна! Несовпадение" 
                                      +"значений семантических характеристик!");
                         ResetJoinSettingsFunc();
                        return;
                           }}
                           
                           else
                           {//при несовпадении наименований семантик
                            if (obj1)
                            {//добавляем соответствующее значение 
                            AddSemanticCode.Add(MapView1.MapSemantics.SemanticCodeName_get(GetSemantName1[g]));
                            AddSemanticValue.Add(GetSemantValue1[g]);
                              obj12count--;
                             }
                             else
                            {
                            AddSemanticCode.Add(MapView1.MapSemantics.SemanticCodeName_get(GetSemantName2[h]));
                            AddSemanticValue.Add(GetSemantValue2[h]);
                               obj12count--;
                              }
                            }

                        }
                    }

                    //выполняем построение объединения
                    bool union = MapCross1.ExecuteUnion();
                    if (union == true)
                    {//снимаем выделение с выбранных объектов
                    MapObj1.Style = axGisToolKit.TxObjectStyle.OS_NORMAL;
                    MapObj2.Style = axGisToolKit.TxObjectStyle.OS_NORMAL;
                     if (obj12count == 0) {
                      if (AddSemanticCode.Count != 0) {  
                    if (MessageBox.Show("Несовпадение количества семантических характеристик." 
                          +"Продолжить обработку?","Сшивка объектов", MessageBoxButtons.YesNo, 
                     MessageBoxIcon.Question) == DialogResult.No )
                      {//прерываем операцию сшивки
                           ResetJoinSettingsFunc();
                             return;
                      }
                      //добавляем недостающие семантики к результирующему объекту
                      for (int k = 0; k <= AddSemanticCode.Count - 1; k++) {
                       MapObj1.Semantic.AddWithValue(AddSemanticCode[k], AddSemanticValue[k]);
                      } } }
                        //сохраняем изменения в объекте
                        MapObj1.Commit();
                        MapObj1.Repaint();
                        MapObj2.Delete();
                        MapView1.Repaint();
                        ResetJoinSettingsFunc();
                        crossobjcount = 0;}

                    else
                    {
                     MessageBox.Show("Ошибка!Возможно ваши объекты имеют разный тип или же не удовлетворяют допуску согласования!");
                     MapObj1.Style = axGisToolKit.TxObjectStyle.OS_NORMAL;
                     MapObj2.Style = axGisToolKit.TxObjectStyle.OS_NORMAL;
                     crossobjcount = 0;
                     MapObj1.ObjHandle = 0;
                     MapObj2.ObjHandle = 0;
                     ResetJoinSettingsFunc();
                    }
                    break;

            }

        }
        public void ResetJoinSettingsFunc()
        {
            obj12count = 0;
            crossobjcount = 0;
            GetSemantName1.Clear();
            GetSemantName2.Clear();
            GetSemantValue1.Clear();
            GetSemantValue2.Clear();
            AddSemanticCode.Clear();
            AddSemanticValue.Clear();

        }
    }
}
