﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;
using System.Runtime.InteropServices;
using System.Globalization;
using System.Xml.Linq;
using System.Xml;


namespace NEW_MAP
{

    public partial class Form1 : Form
    {
        axGisToolKit.TxDoublePoint Point0;
        public static List<int> ObjCopyHandle = new List<int>(), ObjNumberForDelete = new List<int>(), ObjHandleForMove = new List<int>();
        public double x3, y3;
        public bool MoveSetObj;//флаг перемещения нескольких объектов
        //objfordelete - номера по порядку копий объектов для удаления
        //selectobjcount - количество выделенных объектов
        //delta - структура MAPAPI координат точки
        public int objfordelete = 0, selectobjcount=0;
        DOUBLEPOINT delta = new DOUBLEPOINT();

        public void MoveObjects_MouseUp(double ex, double ey)
        {
            //получаем координаты точки отжатия в метрах
            MouseXY.SetPoint(MapView1.MapLeft + ex, MapView1.MapTop + ey);
            MouseXY.GetPoint(ref x3, ref y3);
            //удаляем копии выделенных объектов
            for (int k = 0; k <= ObjNumberForDelete.Count - 1; k++)
            {
                EditMapObj.mapDeleteObjectByNumber(MapView1.MapHandle, 1, ObjNumberForDelete[k]);
                MapObjForMove.Repaint();
                MapView1.Repaint();
            }

            MapFind1.Active = true;
            MapFind1.first();
            while (!MapFind1.Eof)
            {//создаем копию выделенных объектов
            int hobj = EditMapObj.mapCreateCopyObject(MapView1.MapHandle,
                                                      MapObj1.ObjHandle);
              ObjCopyHandle.Add(hobj);
              MapFind1.Next();
            }
            //вычисляем смещение между точками нажатия мыши 
            delta.X = x3 - Point0.X;
            delta.Y = y3 - Point0.Y;

            for (int k = 0; k <= ObjCopyHandle.Count - 1; k++)
            {
             //записываем копии выделенных объектов в MapObjForMove
             MapObjForMove.ObjHandle = ObjCopyHandle[k];
             MapObjForMove.CommitAsNew();
            //перемещаем копии выделенных объектов на величину delta 
            EditMapObj.mapRelocateObject(MapView1.MapHandle,MapObjForMove.ObjHandle, 
                                                                      ref delta, 3);
             MapObjForMove.Commit();
             MapObjForMove.Repaint();
             //сохраняем список копий объекта для последующего их удаления
             objfordelete = EditMapObj.mapGetObjectNumber(MapObjForMove.ObjHandle);
             ObjNumberForDelete.Add(objfordelete);
            }
        
        
        
        }

        public void MoveObjects_MouseDown(double ex, double ey)
        {   //получаем координаты точки нажатия в метрах
         MouseXY.SetPoint(MapView1.MapLeft+ex,MapView1.MapTop+ey);
         MouseXY.GetPoint(ref x2, ref y2);
          if (ObjCopyHandle.Count == 0)
          {//запоминаем координаты точки первого нажатия 
              Point0.X = x2;
              Point0.Y = y2;
           }
         }

        public void MoveObjects_MouseDblClick()
        {
        //удаляем копии выделенных объектов 
        for (int k = 0; k <= ObjNumberForDelete.Count - 1; k++)
        {//определяем порядковый номер копии объекта
         EditMapObj.mapDeleteObjectByNumber(MapView1.MapHandle, 1, 
                                                 ObjNumberForDelete[k]);
         MapObjForMove.Repaint();
         MapView1.Repaint();
         }
         //перемещаем оригиналы выделенных объектов 
         MapFind1.Active = true;
         MapFind1.first();
         while (!MapFind1.Eof){
         EditMapObj.mapRelocateObject(MapView1.MapHandle,MapObj1.ObjHandle,
                                                              ref delta, 3);
         MapObj1.Commit();
         MapFind1.Next();
         }
         //удаляем копии объектов, сбрасываем выделение объектов и флаги
         MoveObjUnCheked();
        }
     
        public void MoveObjUnCheked()
        {
           //удаляем копии выделенных объектов
            if (ObjNumberForDelete.Count > 0)
            {
                for (int k = 0; k <= ObjNumberForDelete.Count - 1; k++)
                {
                    EditMapObj.mapDeleteObjectByNumber(MapView1.MapHandle, 1, ObjNumberForDelete[k]);
                    MapObjForMove.Repaint();
                    MapView1.Repaint();
                }
            }
           MapObj1.Repaint();
           MapView1.Repaint();
           //сбрасываем выделение   
           MapView1.ClearObjectSelected();
           MapView1.ViewSelect.ClearSampleAll();
           ObjHandleForMove.Clear();
           ObjCopyHandle.Clear();
           ObjNumberForDelete.Clear();
           MoveObj.CheckState = System.Windows.Forms.CheckState.Unchecked;
           //сбрасываем флаги и счетчики
           selectobjcount = 0;
           NewObj = false;
           checkobj = false;
           MoveSetObj = false;
        }
     
        public void CheckMoveObj()
        {   //если на карте были выделены объекты
            if (checkobj)
            { //подсчитываем количество выделенных объектов
                MapFind1.Active = true;
                MapFind1.first();
                while (!MapFind1.Eof){
                    selectobjcount++;
                    MapFind1.Next(); }
          string messagemovetext="Вы действительно хотите переместить выбранные объекты ("
                                                             +selectobjcount.ToString()+")?";
          if (MessageBox.Show(messagemovetext, "Перемещение объектов", MessageBoxButtons.YesNo, 
                                                   MessageBoxIcon.Question)== DialogResult.Yes)
                {   //устанавливаем флаг перемещения нескольких объектов
                    MoveSetObj = true; selectobjcount = 0;
                    return;
                } else {
                       MoveObj.CheckState = CheckState.Unchecked;
                       selectobjcount = 0; return;}
            }//если выбранных объектов нет, включаем стандартный режим 
            //редактирования одного объекта
            else MapEditMetric1.MetEditMode = axGisToolKit.TxEditMode.emMove;
        }
    }
}
