﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;
using System.Runtime.InteropServices;
using System.Globalization;
using System.Xml.Linq;
using System.Xml;

namespace NEW_MAP
{
    public partial  class Form1 : Form
    {

        axGisToolKit.axMapPoint MouseXY = new axGisToolKit.axMapPoint();//компонент доступа к координатам векторной карты
        axGisToolKit.axMapPoint XY = new axGisToolKit.axMapPoint();
        axGisToolKit.TxDoublePoint mypoint; //структура - точка метрики, аналогична с структурой Point 
        axGisToolKit.TxDoublePoint xyobjpoint;
       // FMoveObjects MoveObjClass = new FMoveObjects();
        List<axGisToolKit.axMapObj> myObjList = new List<axGisToolKit.axMapObj>();
        axGisToolKit.axMapObj moveobjmap = new axGisToolKit.axMapObj();
        /* переменные int.............
          count_out - счетчик масштабирования, связан с кнопкой уменьшить изображение
          count_in - счетчик масштабирования, связан с кнопкой увеличить изображение
          map_scale - флаг масштабирования изображения, для отжатия кнопок 
          wmap - флаг открытия карты
          rowcount - счетчик строк в DataDridView */
        /* переменные bool...........................
           ZoomMap - флаг масштабирования изображения
           selectclick - флаг выбора объекта по клику
           NumerSemanClick - флаг выбора кнопки анализ числовой семантики
           SelectByClick - флаг выделение объектов по клику
           SelectRect - флаг выбора области на карте
           checkobj - флаг- хотя бы один объект выделен на карте*/
        /* переменные и списки string
            PathShell - путь к приложению
            SubObjList - список подобъектов 
            NumSemValue - список числовых семантик
            GetSemantName - список семантик каждого объекта
            GetSemantName_1 - список всех семантик
            GetSemantValue - список значений семантик каждого объекта
            UnikeSemant - список уникальных семантик
            SemantCode - список кодов семантик по названию семантики
            TypeSemant - список тип семантики по коду
         */
        public COLOR SetColor, SetCol1;//устанавливаем цвет для выделения
        public int count_out = 0, count_in = 0, map_scale = 0, wmap = 0, i = 0, rowcount = 0, size = 3600;
        public bool ZoomMap, SelectRect, SelectByClick, checkobj, NewObj;
        public double xx, yy, x1, y1, x2, y2, SumSquare = 0, SumLength = 0, SumPer = 0, SumNumerSemant = 0, angle, angleold, percision ;
        public string PathShell, ininame, helpname, rscfilename = "";
        public string[] tag;
        public TASKPARMEX param;
        const int ssDouble = 72; // Двойной щелчок мышкой
        private static List<List<string>> KeyObj = new List<List<string>>();
        public List<double> SubObjList = new List<double>(), NumSemValue = new List<double>();
        public List<List<double>> SemantSquare = new List<List<double>>(), GetXYPoint = new List<List<double>>();
        private static List<List<string>> GetSemantName = new List<List<string>>(),GetSemantValue = new List<List<string>>(), el = new List<List<string>>();
        private static List<string> GetSemantName_1 = new List<string>(), UnikeSemant = new List<string>(), UnikNumerSem = new List<string>();
        private static List<int> SemantCode = new List<int>(), TypeSemant = new List<int>(), ObjHandle = new List<int>(), AddSemanticCode = new List<int>();
        private static bool selectclick, NumerSemanClick;
        private static SelectSemantic SemantList = new SelectSemantic();
        public ViewSelect FormViewSel;
       
        public  Form1()
        {
            InitializeComponent();
            //связываем компоненты с MapView1
            MapSelectDialog1.cMapView = MapView1.C_CONTAINER;
            MouseXY.cMapView = MapView1.C_CONTAINER;
            MapDataList1.cMapView = MapView1.C_CONTAINER;
            MapObj1.cMapView = MapView1.C_CONTAINER;
            MapFind1.cMapView = MapView1.C_CONTAINER;
            MapFind1.cMapObj = MapObj1.C_CONTAINER;

            MapObj2.cMapView = MapView1.C_CONTAINER;
            MapFind2.cMapView = MapView1.C_CONTAINER;
            MapFind2.cMapObj = MapObj2.C_CONTAINER;
          
            MapObjForMove.cMapView = MapView1.C_CONTAINER;
            
            MapFindForMove.cMapView = MapView1.C_CONTAINER;
            MapFindForMove.cMapObj = MapObjForMove.C_CONTAINER;

         
          
            XY.cMapView = MapView1.C_CONTAINER;
            MapSelectRect1.cMapView = MapView1.C_CONTAINER;
            SemanticDialog1.cMapView = MapView1.C_CONTAINER;
            SemanticDialog1.cMapFind = MapFind1.C_CONTAINER;
            MapObjForSelect.cMapView = MapView1.C_CONTAINER;
            MapPoint1.cMapView = MapView1.C_CONTAINER;

            MapEditMetric1.cMapView = MapView1.C_CONTAINER;
            MapEditMetric1.cMapObj = MapObj1.C_CONTAINER;
            MapSelectObjectRsc1.cMapView = MapView1.C_CONTAINER;

            MetricDialog1.cMapView = MapView1.C_CONTAINER;
            MetricDialog1.cMapFind = MapFind1.C_CONTAINER;

            GetMapPoint1.cMapView = MapView1.C_CONTAINER;
            GetMapPoint1.cMapObj = MapObj1.C_CONTAINER;

            MapRsc1.cMapView = MapView1.C_CONTAINER;

            
            ForSemantic FormSquareSem = new ForSemantic();

            SetColor = new COLOR();
            SetColor.Init();

            // задаем путь к приложению для ГИС ядра
            PathShell = Path.GetDirectoryName(Application.ExecutablePath) + "\\";
            GisProperty1.mapSetPathShell(PathShell);

            MapView1.PlaceOut = axGisToolKit.TxPPLACE.PP_PICTURE;// устанавливаем систему координат изображения в пикселях
        }
        private void Taskparmex()
        {
            ininame = "C:\\Program Files(x86)\\Panorama\\Panorama Minix64\\panorama.ini";
            helpname = "C:\\Program Files(x86)\\Panorama\\Panorama Minix64\\panorama.chm";
            param = new TASKPARMEX();
            param.Init();
            param.Language = (int)axGisToolKit.TxMAPDLLLANGUAGE.ML_RUSSIAN;
            param.Handle = MapView1.MapHandle;
            param.IniName = Marshal.StringToHGlobalAnsi(ininame);
            param.HelpName = Marshal.StringToHGlobalAnsi(helpname);
            PathShell = Path.GetFullPath(Application.ExecutablePath + "\\");
            param.ApplicationName = Marshal.StringToHGlobalAnsi("NEW_MAP.EXE");
            param.PathShell = Marshal.StringToHGlobalAnsi(PathShell);
            param.Handle = (int)this.Handle;
            param.DocHandle = (int)MapView1.Handle;


        }
        private void SetButton()
        {
            ObjStatistic.Enabled = true;
            SemSquare.Enabled = true;
            SubObject.Enabled = true;
            GetSemantic.Enabled = true;
            SelectNumericSemant.Enabled = true;
        }
        private void SetEditButton ()
        {
          CreateObj.Enabled = true;
          CreateFromFile.Enabled = true;
          CreateObjByType.Enabled = true;
          CreateSubObj.Enabled = true;
          MoveObj.Enabled = true;
          ChangeObjType.Enabled = true;
          DeleteSubObj.Enabled = true;
          DeleteAllSubObj.Enabled = true;
          DeleteObj.Enabled = true;
          EditObjMetric.Enabled = true;
          MoveObjPoint.Enabled = true;
          RemObjPoint.Enabled = true;
          AddObjPoint.Enabled = true;
        }
        private void MenuStrip(object sender, EventArgs e)
        {
            if (sender == mnOpenMap)
            {
                if (OpenMapDialog1.Execute)
                {
                    // открыть карту
                    MapView1.MapOpen(OpenMapDialog1.FileName, true);
                    MapView1.Repaint();
                }
                EditMap.Enabled = true;
                SetEditButton();
            }
            MapInfoStrip.Text = MapView1.MapName + " " + "1:" + MapView1.MapScale.ToString();

            if (sender == mnAddMap)
            {//добавить карту
                if (OpenMapDialog1.Execute)
                {
                    MapView1.AppendData(OpenMapDialog1.FileName, 1);
                    MapView1.Repaint();
                }
            }

            if (sender == mnCreateUserMap) {
            //инициализируем структуру параметров для диалога
            Taskparmex();
            //инициализируем класс, предоставляющий изменяемую строку символов
            StringBuilder mapname = new StringBuilder(256);
            //вызываем диалог "Создание карты"
            PASPAPI.paspCreateMap(MapView1.MapHandle, mapname, size, ref param);
            MapView1.MapOpen(mapname.ToString(), true);
            MapView1.Repaint();
            }

            if (sender == mnCreatePlan) {
            //инициализируем структуру параметров для диалога
            Taskparmex();
            //инициализируем класс, предоставляющий изменяемую строку символов
            StringBuilder mapname = new StringBuilder(256);
            //вызываем диалог "Создание плана"
            PASPAPI.paspCreatePlan(mapname, size, ref param);
            MapView1.MapOpen(mapname.ToString(), true);
            MapView1.Repaint();
            }


            //закрыть карту
            if (sender == mnCloseMap)
            {
                CloseMap_Click(sender, e);
            }//список данных карты
            if (sender == mnListMap)
            {
                ListMap_Click(sender, e);
            }//состав отображения
            if (sender == mnStructMap)
            {
                StructMap_Click(sender, e);
            }
            if (sender == mnPlaceInMap)
            {
                PlaceInMap.CheckState = CheckState.Checked;
            }
            if (sender == mnPlaceOutMap)
            {
                PlaceOutMap.CheckState = CheckState.Checked;
            }
            if (sender == mnOneToOne)
            {
                OneToOne_Click(sender, e);
            }
            if (sender == mnMapOnWindow)
            {
                MapOnWindow_Click(sender, e);
            }
            if (sender == mnSearchDialog)
            {
                SearchDialog.CheckState = CheckState.Checked;
                SearchDialog_Click(sender, e);
            }
            if (sender == mnSearchSemantic)
            {
                SearchSemantic_Click(sender, e);
            }
            if (sender == mnSearchArea)
            {
                MapSelectRect1.StartAction();
                SelectRect = true;
                SelectArea.CheckState = CheckState.Checked;
            }
            if (sender == mnSelectByClick)
            {
                SelectByClick = true;
                SelectClick.CheckState = CheckState.Checked;
            }
            if (sender == mnSelectArea)
            {
                SelectRect = true;
                MapSelectRect1.StartAction();
            }
            if (sender == mnClearSelect)
            {
                ClearSelection_Click(sender, e);
            }
            if (sender == mnDataAnalyze)
            {
                Form1 form = new Form1();
                //управление отображением панели инструментов "Анализ данных"
                if (DataAnalyze.Visible == true)
                {
                    DataAnalyze.Visible = false;
                    MapView1.Width = MapView1.Width + 52;
                    DataAnalyze.Location = new Point(DataAnalyze.Location.X - DataAnalyze.Width, DataAnalyze.Location.Y);


                }
                else
                {
                    DataAnalyze.Visible = true;
                    MapView1.Width = MapView1.Width - 52;
                    DataAnalyze.Location = new Point(DataAnalyze.Location.X + DataAnalyze.Width, DataAnalyze.Location.Y);

                    if (checkobj == true)
                    {
                        ObjStatistic.Enabled = true;
                        SemSquare.Enabled = true;
                        SubObject.Enabled = true;
                        GetSemantic.Enabled = true;
                        SelectNumericSemant.Enabled = true;
                    }
                    else
                    {
                        SemSquare.Enabled = false;
                        SubObject.Enabled = false;
                        GetSemantic.Enabled = false;
                        SelectNumericSemant.Enabled = false;
                        ObjStatistic.Enabled = false;
                    }
                }
            }
            if (sender == mnEditMap)
            {
                if (EditMap.Visible == true)
                {
                    EditMap.Visible = false;
                    MapView1.Width = MapView1.Width + 52;
                    MapView1.Location = new Point(EditMap.Location.X, MapView1.Location.Y);


                }
                else
                {
                        EditMap.Visible = true;
                        MapView1.Width = MapView1.Width - 52;
                        MapView1.Location = new Point(MapView1.Location.X + 52, MapView1.Location.Y);
                        if (MapView1.MapShow)
                        {
                            SetEditButton();
                        }
                }
            }
            if (sender == mnCallHelp)
            {
                Help.ShowHelp(this, @"Panorama.chm");
            }
            if (sender == mnAboutProgram)
            {
                MessageBox.Show("Данная программа демонстрирует возможности использования средства разработки приложений GIS ToolKit Active. Данное приложение содержит основные функции по работе с картой. В последующих уроках планируется рассмотрение создания собственной карты, работа с метрикой объектов, работа с растрами, матрицами.");
            }
        }
        private void ButtonAction(object sender, EventArgs e)
        {
            //если режим был включен - выключить
            NewObj = false;
            MapEditMetric1.StopAction();
           
            
            switch (sender.ToString())
            {
                case "Создать объект": CreateObjectFunc();  break;
                case "Создать объект из XML файла": CreateObjectFromFileFunc();  break;
                case "Создать объект по типу": MapEditMetric1.MetEditMode = axGisToolKit.TxEditMode.emCreate;  break;
                case "Создать подобъект": MapEditMetric1.MetEditMode = axGisToolKit.TxEditMode.emCreateSubj; break;
                case "Переместить объект": if (MoveObj.Checked) CheckMoveObj();
                                          else { MoveSetObj = false; MoveObjUnCheked(); }  break;
                case "Переместить точку метрики": MapEditMetric1.MetEditMode = axGisToolKit.TxEditMode.emEdit;  break;
                case "Добавить точку метрики": MapEditMetric1.MetEditMode = axGisToolKit.TxEditMode.emAddPoint;  break;
                case "Удалить точку метрики": MapEditMetric1.MetEditMode = axGisToolKit.TxEditMode.emRemPoint;  break;
                case "Удалить объект": { DeleteObjFunc(); if (!DeleteObj.Checked) return; }break;
                case "Удалить подобъект": if (!DeleteSubObj.Checked) { GetMapPoint1.StopAction(); return; } else NewObj = true; break;
                case "Нарезка и сшивка объектов": CrossObjFunc(); break;
                case "Сшивка объектов": if (!JoinObj.Checked) {
                                        MapObj1.Style = axGisToolKit.TxObjectStyle.OS_NORMAL;
                                        return; }  break;
                case "Нарезка объекта": cutobjcount = 1;  break;
                case "Параметры редактора":   EditSettingsFunc(); return;
            }

            //изменяем значение флага создания объекта
            NewObj = true;
        }

        public void EditSettingsFunc()
        {
        
         EditSettings.CheckState = CheckState.Unchecked; 
         NewObj = false;
         JoinPrecision JoinForm = new JoinPrecision();
         //если допуск был сохранен как параметр приложения, 
         //выводим его в TextBox
         JoinForm.textBox1.Text = percision.ToString();
         DialogResult dialogResult = JoinForm.ShowDialog();
         //если нажали кнопку "Установить"
         if (dialogResult == System.Windows.Forms.DialogResult.OK)
            try
           {//устанавливаем значение, равное введенному в TextBox
             percision = Convert.ToDouble(JoinForm.textBox1.Text);
            }
             catch (Exception ex)
            { //если ввели неверное значение допуска
             percision = 0.00;
          MessageBox.Show("Введенное значение является некорректным!");
             dialogResult = JoinForm.ShowDialog();
             }
           
          }


        public void DeleteObjFunc()
        { 
         //если на карте были выделены объекты
         if (checkobj)
         {//подсчитываем количество выделенных объектов
            MapFind1.Active = true;
            MapFind1.first();
            while (!MapFind1.Eof) {
            //увеличиваем счетчик количества объектов
              selectobjcount++;
              MapFind1.Next(); }

            //удаляем выделенные объекты по клику мыши
            if (ObjHandle.Count != 0)
            {
                string messagedeltext = "Вы действительно хотите удалить выбранные объекты ("
                                                       + ObjHandle.Count.ToString() + ")?";
                if (MessageBox.Show(messagedeltext, "Удаление объектов", MessageBoxButtons.YesNo,
                                                  MessageBoxIcon.Question) == DialogResult.Yes)
                {
                  for (int k = 0; k <= ObjHandle.Count - 1; k++)
                 {
                  //удаляем объекты по порядковому номеру
                  EditMapObj.mapDeleteObjectByNumber(MapView1.MapHandle, 1, ObjHandle[k]);
                 }
                    ObjHandle.Clear();
                    MapView1.Repaint();
                    MapObj1.ObjHandle = 0;
                    //сбрасываем флаг выделения объектов
                    checkobj = false;
                    DeleteObj.CheckState = CheckState.Unchecked;
                }
                else
                {
                    DeleteObj.CheckState = CheckState.Unchecked;  
                }
            }//удаляем объекты выделенные любым другим способом
            else 
            { 
             string messagedeltext = "Вы действительно хотите удалить выбранные объекты (" 
                                                       + selectobjcount.ToString() + ")?";
           if (MessageBox.Show(messagedeltext, "Удаление объектов", MessageBoxButtons.YesNo, 
                                             MessageBoxIcon.Question) == DialogResult.Yes)
           { 
              DeleteObj.CheckState = CheckState.Unchecked;  
           
               MapFind1.Active = true;
               MapFind1.first();
               while (!MapFind1.Eof)  {
                //удаляем объекты
                  MapObj1.Delete();
                  MapFind1.Next();
                }
                //сбрасываем счетчик количества объектов и флаг выделения объектов
                    selectobjcount = 0;
                    checkobj = false;
                }
                else {
                     
                  DeleteObj.CheckState = CheckState.Unchecked;
                  selectobjcount = 0;
                  return;
                } 
            }
         }
     }

        public void CrossObjFunc()
        {
         //устанавливаем значение допуска согласования,
         //если оно не было установлено ранее
         if (percision == 0)
            EditSettingsFunc();
         //устанавливаем панель инструментов "Нарезка и сшивка" 
         //внизу поля карты
         if (CrossBox.Visible == true)
         {
          CrossBox.Visible = false;
          MapView1.Height = MapView1.Height + 61;
          CrossMapObj.CheckState = CheckState.Unchecked;
          }
          else {
          CrossBox.Visible = true;
          MapView1.Height = MapView1.Height - 61;
          CrossMapObj.CheckState = CheckState.Unchecked;
          }    
        }


        private void OpenMap_Click(object sender, EventArgs e)
        {
            // открываем карту
            if (OpenMapDialog1.Execute)
            {
                if (wmap != 1)//если карта еще не открыта
                {   // открыть карту
                    MapView1.MapOpen(OpenMapDialog1.FileName, true);
                    MapView1.Repaint();

                }
                else
                {
                    // добавляем карту к уже открытой
                    MapView1.AppendData(OpenMapDialog1.FileName, 1);
                }

            }
            wmap = 1;// изменяем значение флага открытия карты
            OpenMap.CheckState = CheckState.Unchecked; // отжать кнопку после открытия карты

            // выведем название карты и основной масштаб в окно статуса
            MapInfoStrip.Text = MapView1.MapName + " " + "1:" + MapView1.MapScale.ToString();

        }

        private void StructMap_Click(object sender, EventArgs e)
        {
            //здесь и далее при нажатии любой из кнопок после масштабирования отжимать кнопки увеличить или уменьшить изображение
            PlaceInMap.CheckState = CheckState.Unchecked;
            PlaceOutMap.CheckState = CheckState.Unchecked;

            //диалог выбора условий отображения объектов
            if (MapSelectDialog1.Execute(MapView1.ViewSelect, false) == true)
            {
                MapView1.Repaint();//перерисовка карты
            }
            StructMap.CheckState = CheckState.Unchecked;
        }

        private void ListMap_Click(object sender, EventArgs e)
        {

            PlaceInMap.CheckState = CheckState.Unchecked;
            PlaceOutMap.CheckState = CheckState.Unchecked;

            // диалог список данных карты
            MapDataList1.stdExecute();
            MapView1.Repaint();
            ListMap.CheckState = CheckState.Unchecked;
        }

        private void PlaceInMap_Click(object sender, EventArgs e)
        {
            //данное событие понадобится при дальнейшем добавлении функционала
        }

        private void PlaceOutMap_Click(object sender, EventArgs e)
        {
            //данное событие понадобится при дальнейшем добавлении функционала
        }

        private void OneToOne_Click(object sender, EventArgs e)
        {

            PlaceInMap.CheckState = CheckState.Unchecked;
            PlaceOutMap.CheckState = CheckState.Unchecked;
            // изображение 1:1
            MapView1.ViewScale = MapView1.MapScale;//текущий масштаб приравнять основному масштабу карты
            MapView1.Repaint();
            OneToOne.CheckState = CheckState.Unchecked;
        }

        private void MapOnWindow_Click(object sender, EventArgs e)
        {

            PlaceInMap.CheckState = CheckState.Unchecked;
            PlaceOutMap.CheckState = CheckState.Unchecked;
            // изображение размещается в пределах текущего размера окна
            MapView1.ShowAllMapInWindow();
            MapView1.Repaint();
            MapOnWindow.CheckState = CheckState.Unchecked;
        }

        private void CloseMap_Click(object sender, EventArgs e)
        {
            // закрываем карту
            PlaceInMap.CheckState = CheckState.Unchecked;
            PlaceOutMap.CheckState = CheckState.Unchecked;

            wmap = 0; //изменяем значения флага открытия карты
            // очищаем нижние панели статусов
            MapInfoStrip.Text = " ";
            ChangeScaleStrip.Text = " ";
            korX.Text = " ";
            korY.Text = " ";
            // очищаем список выделенных объектов
            MapView1.ClearObjectSelected();
            MapView1.ViewSelect.ClearSampleAll();
            MapFind1.cMapSelect.ClearAll();
            checkobj = false;

            EditMap.Enabled = false;
 
            MapView1.MapClose();
            MapView1.MapShow = false;
            CloseMap.CheckState = CheckState.Unchecked;
        }
        private void Form1_FormClosed(object sender, FormClosedEventArgs e)
        { // закрываем карту 
            MapView1.ClearObjectSelected();
            MapView1.ViewSelect.ClearSampleAll();
            MapFind1.cMapSelect.ClearAll();
            checkobj = false;
          
            MapView1.MapClose();

        } 
        public void ZoomMapFunc(double ex, double ey, axGisToolKit.TxMouseButton button)
        {
            MouseXY.PlaceInp = axGisToolKit.TxPPLACE.PP_PICTURE; // устанавливаем систему координат на запись в пикселях

                mypoint.X = ex;
                mypoint.Y = ey;
                MouseXY.SetPoint(mypoint.X, mypoint.Y);// устанавливаем координаты точки метрики в системе заданной свойством PlaceIn

                // если нажата левая кнопка мыши - изменить масштаб
                if (button == axGisToolKit.TxMouseButton.mbLeft)
                {
                    if (PlaceOutMap.Checked)//если нажата кнопка уменьшить масштаб 
                    {
                        MapView1.ViewScale = MapView1.ViewScale * 2;
                        MapView1.ScaleInPoint(MapView1.ViewScale, MouseXY.C_CONTAINER);

                        count_out++;//увеличиваем счетчик уменьшения изображения
                    }
                    else
                    {
                        if (PlaceInMap.Checked)//если нажата кнопка увеличить масштаб
                        {
                            MapView1.ViewScale = MapView1.ViewScale / 2;
                            MapView1.ScaleInPoint(MapView1.ViewScale, MouseXY.C_CONTAINER);
                            count_in++;//увеличиваем счетчик увеличения изображения

                      }
                  }
             }  
        }
        private void MapView1_OnMapMouseUp(object sender, AxaxGisToolKit.IaxMapViewEvents_OnMapMouseUpEvent e)
        {
            if (CutObj.Checked)
            {
                cutobjcount = 2;
                return;
            }
            if (MoveObj.Checked){
                //проверяем, что перемещаем выделенные объекты
                if (MoveSetObj){
                 MoveObjects_MouseUp(e.x, e.y);
                 return;
               }
            }

            if (NewObj) return;
                
            if (SelectClick.Checked)
                SelectByClick = true;
            else SelectByClick = false;

            if (SelectArea.Checked || SelectObjArea.Checked)
                SelectRect = true;



            if (count_out > 0 && PlaceInMap.Checked)// если нажата кнопка уменьшить масштаб и счетчик уменьшения масштаба>0
               {
                 PlaceOutMap.CheckState = CheckState.Unchecked;// отжимаем кнопку увеличения масштаб
                 count_out = 0;
               } else {
                   if (count_in > 0 && PlaceOutMap.Checked){
                     PlaceInMap.CheckState = CheckState.Unchecked;
                     count_in = 0;
                   }
                      }

            if (PlaceOutMap.Checked || PlaceInMap.Checked)//если нажата одна из кнопок масштабирования
                ZoomMap = true;//изменяем флаг масштабирования изображения
            else ZoomMap = false;

            if (ZoomMap == false && SelectRect == false && SelectByClick == false && NewObj==false)
              {// выбрать объект карты по нажатию мыши 
                MapFind1.cMapObj.SelectObjectInPoint((int)e.x - MapView1.MapLeft, (int)e.y - MapView1.MapTop, 4, 0);
              }

            if (ZoomMap) // если активен режим масштабирования в точке нажатия
              {
                axGisToolKit.TxMouseButton button;
                button = (axGisToolKit.TxMouseButton)e.button;
                ZoomMapFunc(e.x, e.y, button);
              }

            if (SelectRect)
               SelectionRect();
            
            if (SelectByClick)//выделение кликом
               SelectByClickFunc(e.x, e.y);

        }
       
        public void SelectByClickFunc(double ex, double ey)
        {
             checkobj = true;// устанавливаем флаг выделения объектов
                MapFind1.Active = false;
                MapFind1.FindPoint = true; //включаем режим поиска в заданной точке
                // координаты и радиус поиска
                MapFind1.X = ex;
                MapFind1.Y = ey;
                MapFind1.Radius = 3;
                MapFind1.Active = true;
                //если объект невозможно добавить к списку, то функция возвращает 0
                if (MapView1.ViewSelect.SelectSample(true, MapObj1.ListName, MapObj1.Key) > 0)
                {
                    //выделяем найденный объект
                    MapView1.SetViewSelected(true, SetColor.aColor);
                    MapObj1.Repaint();
                }
                else MapView1.SetViewSelected(false, SetColor.aColor);


                SetButton();
                // определяем номер, ключ, локализацию и тип объекта
                string key = MapObj1.Key.ToString();
                string keyname = MapObj1.KeyName;
                string localtype = MapObj1.Local.ToString();
                switch (localtype)
                {
                    case "OL_MARK": localtype = "точечный";
                        break;
                    case "OL_SQUARE": localtype = "площадной";
                        break;
                    case "OL_LINE": localtype = "линейный";
                        break;
                    case "OL_TEXT": localtype = "подпись";
                        break;
                    case "OL_VECTOR": localtype = "векторный";
                        break;
                }
                string objname = MapObj1.ObjName;

                ObjHandle.Add(EditMapObj.mapGetObjectNumber(MapObj1.ObjHandle));



                //список для хранения количества подобъектов в объекте
                SubObjList.Add(MapObj1.Metric.SubjectCount);

                GetSemantName.Add(new List<string>());
                GetSemantValue.Add(new List<string>());

                //заполняем списки именами семантик и их значениями
                for (int j = 1; j <= MapObj1.Semantic.SemanticCount; j++)
                {
                    GetSemantName[i].Add(MapObj1.Semantic.SemanticName_get(j));
                    GetSemantName_1.Add(MapObj1.Semantic.SemanticName_get(j));
                    GetSemantValue[i].Add(MapObj1.Semantic.SemanticValue_get(j));
                }
                UnikNumerSem = GetSemantName_1.Distinct().ToList();

                UnikeSemant = GetSemantName_1.Distinct().ToList();
                KeyObj.Add(new List<string>());
                KeyObj[i].Add(key);
                KeyObj[i].Add(keyname);
                KeyObj[i].Add(localtype);
                KeyObj[i].Add(objname);
                // определяем площадь, периметр и длину каждого объекта 
                //заполняем список для хранения характеристик объектов
                SemantSquare.Add(new List<double>());
                SemantSquare[i].Add(MapObj1.SquareInMap());
                SemantSquare[i].Add(MapObj1.Perimeter);
                SemantSquare[i].Add(MapObj1.LengthInMap());

                i++;
                selectclick = true;
        }
        private void MapView1_OnDblClick(object sender, EventArgs e)
        {
            if (MoveSetObj)
            {
                MoveObjects_MouseDblClick();
            }
        }
        private void SelectionRect()
        {
            if (MapSelectRect1.Selection)
            {
                // Создать пустой объект
                MapObjForSelect.CreateObjectByExcode(0, (int)axGisToolKit.TxMetricType.IDFLOAT2, 1000000005, (int)axGisToolKit.TxObjectLocal.OL_SQUARE);
                // Установить метрику созданного объекта

                MapSelectRect1.PPlace = axGisToolKit.TxPPLACE.PP_PLANE;
                MapPoint1.PlaceInp = axGisToolKit.TxPPLACE.PP_PLANE;

                axGisToolKit.TxDoublePoint mypoint;

                mypoint.X = MapSelectRect1.SelectedRect.X1;
                mypoint.Y = MapSelectRect1.SelectedRect.Y1;
                MapPoint1.SetPoint(mypoint.X, mypoint.Y);

                MapObjForSelect.Metric.Append(0, MapPoint1.C_CONTAINER);

                mypoint.X = MapSelectRect1.SelectedRect.X1;
                mypoint.Y = MapSelectRect1.SelectedRect.Y2;
                MapPoint1.SetPoint(mypoint.X, mypoint.Y);

                MapObjForSelect.Metric.Append(0, MapPoint1.C_CONTAINER);


                mypoint.X = MapSelectRect1.SelectedRect.X2;
                mypoint.Y = MapSelectRect1.SelectedRect.Y2;
                MapPoint1.SetPoint(mypoint.X, mypoint.Y);

                MapObjForSelect.Metric.Append(0, MapPoint1.C_CONTAINER);

                mypoint.X = MapSelectRect1.SelectedRect.X2;
                mypoint.Y = MapSelectRect1.SelectedRect.Y1;
                MapPoint1.SetPoint(mypoint.X, mypoint.Y);

                MapObjForSelect.Metric.Append(0, MapPoint1.C_CONTAINER);
                MapObjForSelect.Commit();
                MapFind1.cMapSelect.SiteNumber = 0;   // основная карта
                MapFind1.cMapSelect.UnselectSeekArea(-1);  // сбросим область если была выбрана
                if (MapObjForSelect.Key == 0)
                {
                    MessageBox.Show("Объект не создан!");
                    return; // объекта карты нет
                }

                // установим область по созданному ранее объекту

                MapFind1.Active = false;
                MapFind1.FindPoint = false;

                if (SelectArea.Checked)//если нажата кнопка поиска по области
                {

                    MapFind1.cMapSelect.SelectSeekArea(-1, MapObjForSelect.C_CONTAINER, 0, 0, 2, 1, 0);

                    MapObjForSelect.Delete();
                    MapFind1.Active = true;
                    MapObjForSelect.ExecuteDlgFind(MapFind1.cMapSelect, false, 1);
                    MapSelectRect1.StopAction();
                    MapView1.Repaint();
                    SelectArea.CheckState = CheckState.Unchecked;

                }
                else
                {
                    checkobj = true;

                    // если выделяем по области
                    MapSelectRect1.StopAction();
                    //устанавливаем область для выделения
                    MapFind1.cMapSelect.SelectSeekArea(-1, MapObjForSelect.C_CONTAINER, 0, 1, 2, 1, 0);
                    //активизируем поисковую систему
                    MapFind1.Active = true;
                    MapView1.Rendering = false;
                    MapFind1.first();
                    //пока не достигнут последний элемент
                    while (!MapFind1.Eof)
                    {//добавляем в список объектов
                        MapView1.ViewSelect.SelectSample(true, MapObj1.ListName, MapFind1.cMapObj.Key);
                        MapFind1.Next();
                    }
                    MapView1.SetViewSelected(true, SetColor.aColor);


                    SetButton();

                    MapView1.Rendering = true;
                    MapObjForSelect.Delete();


                    SelectArea.Checked = false;
                    SelectObjArea.Checked = false;
                    SelectRect = false;
                }
            }

        }

        private void MapView1_OnMapMouseMove(object sender, AxaxGisToolKit.IaxMapViewEvents_OnMapMouseMoveEvent e)
        {
            if (!MapView1.MapShow)// если карта отображается в MapView1
                return;
          
            // Выведем координаты и текущий масштаб в окно статуса
            ChangeScaleStrip.Text = "1:" + MapView1.ViewScale.ToString();


            MouseXY.SetPoint(MapView1.MapLeft + e.x, MapView1.MapTop + e.y);// устанавливаем координаты точек метрики в пикселях
            MouseXY.GetPoint(ref xx, ref yy);//получаем в метрах


            korX.Text = xx.ToString("X= 0.00 м");
            korY.Text = yy.ToString("Y= 0.00 м");
        }
     
        public void MapView1_OnMapMouseDown(object sender, AxaxGisToolKit.IaxMapViewEvents_OnMapMouseDownEvent e)
        { 

            MouseXY.SetPoint(MapView1.MapLeft + e.x, MapView1.MapTop + e.y);
            MouseXY.GetPoint(ref x1, ref y1);

            if (MoveObj.Checked) {
                if (MoveSetObj){
                    MoveObjects_MouseDown(e.x, e.y);
                    return;
                }

            }
            if (CutObj.Checked)
            {
                CutObjectFunc(e.x, e.y);
                return;

            }

            if (JoinObj.Checked){
                JoinObjectFunc(e.x, e.y);
                 return;
            }

            int button;
            button = e.shift;
            EditObjFunc(e.x, e.y, button);
        }

        public void EditObjFunc(double ex, double ey, int button)
       { 
            if (!NewObj) return; //процесс редактирования не включали
            
            if (MapEditMetric1.Active) return; //процесс уже идет
           
            //выбираем объект для редактирования
            if (button == ssDouble || MapObj1.Key == 0)
            {
                MapFind1.Active = false;
                //включаем режим поиска в заданной точке
                MapFind1.FindPoint = true;
                // координаты и радиус поиска
                MapFind1.X = ex;
                MapFind1.Y = ey;
                MapFind1.Radius = 2;
                MapFind1.Active = true;
            }
           

            if (EditObjMetric.Checked)
            { 
                //вызываем диалог редактирования метрики
                MetricDialog1.Execute();
                MapObj1.Style = axGisToolKit.TxObjectStyle.OS_NORMAL;
                MapObj1.Repaint();
                MapObj1.ObjHandle = 0;
                NewObj = false;
                EditObjMetric.CheckState = CheckState.Unchecked;
                return;
            }

            if (DeleteSubObj.Checked)
            {
             //включаем режим выбора точки
             GetMapPoint1.StartAction();
             //устанавливаем возможность выбора любой точки на контуре
             GetMapPoint1.TypeGetPoint=axGisToolKit.TxTypeGetPoint.GetVirtualPoint;
             return;
            }

            if (DeleteAllSubObj.Checked)
            {   //определяем характер локализации объекта
                string localtype = MapObj1.Local.ToString();
                if (localtype=="OL_SQUARE" || localtype=="OL_LINE" || localtype=="OL_TEXT")
                 {//определяем количество подобъектов в объекте
                    int subcount = MapObj1.Metric.SubjectCount;
                    for (int i = subcount; i <= subcount; i--){
                        if (i > 0) {
                    //удаляем подобъекты
                    EditMapObj.mapDeleteSubject(MapObj1.ObjHandle, i);
                    MapObj1.Commit();
                    MapObj1.Repaint();
                    MapView1.Repaint(); }
                       else break;}
                }
                NewObj = false;
                DeleteAllSubObj.CheckState = CheckState.Unchecked;
                return;
            }

            if (ChangeObjType.Checked)
            { //объявляем структуру - описание выбранного объекта карты
             axGisToolKit.TxMapObjectInfo objinfo = new axGisToolKit.TxMapObjectInfo();
             //вызываем диалог выбора вида объекта из классификатора
             MapSelectObjectRsc1.Execute(ref objinfo);
             //определяем порядковый номер объекта
             int objnumber = EditMapObj.mapGetObjectNumber(MapObj1.ObjHandle);
             //устанавливаем новое описание объекта карты
             MapObj1.SetObjectByExcode((int)axGisToolKit.TxMetricType.IDFLOAT2, 
                                                    objinfo.ExCode, objinfo.Local);
             //удаляем объект с старым описанием
             EditMapObj.mapDeleteObjectByNumber(MapView1.MapHandle, 1, objnumber);
             //записываем объект в карту как новый
             MapObj1.CommitAsNew();
             MapObj1.Repaint();
             MapView1.Repaint();
             MapObj1.ObjHandle = 0;
             NewObj = false;
             ChangeObjType.CheckState = CheckState.Unchecked;
             return;
            }

            // по нажатию правой кнопки мыши начинаем создавать объект по типу
            if (button==(int)axGisToolKit.TxShiftState.gtkRight && CreateObjByType.Checked)
            {
                MapEditMetric1.StartAction();
            }

           //если выбрали объект-подпись
           if (CreateObjByType.Checked && MapObj1.Local == axGisToolKit.TxObjectLocal.OL_TEXT)
           {
               EditText EditTextForm = new EditText();
               //получаем текст подписи
               EditTextForm.textBox1.Text = MapObj1.Text_get(0);
               DialogResult dialogResult = EditTextForm.ShowDialog();
               if ((dialogResult == DialogResult.OK) && (EditTextForm.textBox1.Text.Length > 0))
               {//устанавливаем текст подписи
                   MapObj1.Text_set(0, EditTextForm.textBox1.Text);
               }
           }


           if (MapObj1.Key != 0 || MapObj1.Metric.PointCount_get(0) != 0)
           {
               if (!CreateSubObj.Checked)
                   MapObj1.Style = axGisToolKit.TxObjectStyle.OS_SELECT;
               if (!DeleteObj.Checked)
               {
                   //если выбрали объект-подпись
                   if (CreateObjByType.Checked && MapObj1.Local == axGisToolKit.TxObjectLocal.OL_TEXT)
                   {
                       EditText EditTextForm = new EditText();
                       //получаем текст подписи
                       EditTextForm.textBox1.Text = MapObj1.Text_get(0);
                       DialogResult dialogResult = EditTextForm.ShowDialog();
                       if ((dialogResult == DialogResult.OK) && (EditTextForm.textBox1.Text.Length > 0))
                       {
                           MapObj1.Text_set(0, EditTextForm.textBox1.Text);
                       }
                   }
                   if (!CreateObjByType.Checked && !EditObjMetric.Checked && !DeleteSubObj.Checked && !DeleteAllSubObj.Checked && !ChangeObjType.Checked)
                       //активируем режим редактирования
                       MapEditMetric1.StartAction();
               }
               else
               {
                   if (MessageBox.Show("Вы действительно хотите удалить объект?") == DialogResult.OK)
                   { //удалить объект
                       MapObj1.Delete();
                       MapObj1.ObjHandle = 0;
                       NewObj = false;
                   }
                   else
                   {
                       if (MessageBox.Show("Вы действительно хотите удалить объект?") == DialogResult.No)
                           NewObj = false;
                           return;
                   }
                   DeleteObj.CheckState = CheckState.Unchecked;


               }
           }
    
    
       }
        private void SearchDialog_Click(object sender, EventArgs e)
        {
            if (SearchDialog.Checked)
            {//деактивируем систему поиска для очистки ранее найденных объектов
                if (MapFind1.Active)
                    MapFind1.Active = false;
                //открытие диалога выбора условий поиска
                if (MapSelectDialog1.Execute(MapFind1.cMapSelect, true))
                {
                    if (MapSelectDialog1.ModalResult == 1)//найти
                    {
                        MapFind1.Active = true;
                        //перемещаем объект в центр поля отображения
                        MapFind1.Center();
                        //диалог отображения данных о найденном объекте
                        MapObj1.ExecuteDlgFind(MapFind1.cMapSelect, false, 1);
                    }
                    if (MapSelectDialog1.ModalResult == 8) // выделить
                    {
                        checkobj = true;//устанавливаем флаг выделения объектов
                        //устанавливаем параметры группового выделения
                        MapView1.SetObjSelected(MapFind1.cMapSelect, SetColor.aColor, true);

                        SetButton();
                    }
                }
                SearchDialog.CheckState = CheckState.Unchecked;
            }

        }

        private void SearchSemantic_Click(object sender, EventArgs e)
        {
            int semparam;
            Taskparmex();//инициализация структуры TASKPARMEX
            ARRAYNAME arname = new ARRAYNAME();
            arname.Init();//инициализация структуры ARRAYNAME

            //вызов функции поиска по названию
            semparam = Semantic_DLG.selSearchName(MapView1.MapHandle, MapFind1.MapSelectHandle, ref arname, ref param);

            if (semparam == 1)//найти 
            {
                MapFind1.Active = true;//активизируем систему поиска
                //перемещаем объект в центр поля отображения
                MapFind1.Center();
                //диалог отображения данных о найденном объекте
                MapObj1.ExecuteDlgFind(MapFind1.cMapSelect, false, 1);
            }
            if (semparam == 2)//выделить
            {
                checkobj = true;//устанавливаем флаг выделения объектов
                //устанавливаем параметры группового выделения
                MapView1.SetObjSelected(MapFind1.cMapSelect, SetColor.aColor, true);

                SetButton();
            }
        }

        private void SelectArea_Click(object sender, EventArgs e)
        { // Выбор области
            if (SelectArea.Checked)
                MapSelectRect1.StartAction();//включить режим выбора
            else MapSelectRect1.StopAction();
        }

        private void ContinueSearch_Click(object sender, EventArgs e)
        {//продолжить поиск объектов с выбранного
            MapObj1.ExecuteDlgFind(MapFind1.cMapSelect, true, 1);
            MapFind1.cMapObj.Center();
            ContinueSearch.CheckState = CheckState.Unchecked;
        }

        private void SelectClick_Click(object sender, EventArgs e)
        {

        }

        private void ClearSelection_Click(object sender, EventArgs e)
        {  //инициализируем формы для очистки соответствующих им DataGridView
            FormViewSel = new ViewSelect();
            ForSemantic FormSquareSem = new ForSemantic();
            ForSubObj SubObjForm = new ForSubObj();
            ForStringSemant StringSemantForm = new ForStringSemant();
            // снимаем выделение объектов
            MapView1.ClearObjectSelected();
            MapView1.ViewSelect.ClearSampleAll();
            MapFind1.cMapSelect.ClearAll();

            checkobj = false;//изменяем флаг выбора объектов
            NumerSemanClick = false;
            MapView1.Repaint();
            //делаем неактивными кнопки панели анализ данных
            ObjStatistic.Enabled = false;
            SemSquare.Enabled = false;
            SubObject.Enabled = false;
            GetSemantic.Enabled = false;
            SelectNumericSemant.Enabled = false;
            ObjStatistic.Enabled = false;
            //заполняем DataGridView пустым ресурсом
            List<string> Empty = new List<string>();
            FormViewSel.SemGridView.DataSource = Empty;
            FormSquareSem.SquereAnalyzeGrid.DataSource = Empty;
            SubObjForm.SubObjGrid.DataSource = Empty;
            StringSemantForm.ViewSemantGrid.DataSource = Empty;
            //сбрасываем значения площади, периметра,длины,количества строк,количества объектов
            SumSquare = 0;
            SumPer = 0;
            SumLength = 0;
            i = 0;
            rowcount = 0;
            //очищаем все списки
            KeyObj.Clear();
            SemantSquare.Clear();
            SubObjList.Clear();
            GetSemantName_1.Clear();
            GetSemantName.Clear();
            GetSemantValue.Clear();
            SemantCode.Clear();
            TypeSemant.Clear();
            ObjHandle.Clear();
            ClearSelection.CheckState = CheckState.Unchecked;
            SelectClick.CheckState = CheckState.Unchecked;

        }

        private void SelectObjArea_Click(object sender, EventArgs e)
        {
            if (SelectObjArea.Checked)
            {
                MapSelectRect1.StartAction();//включить режим выбора точки
                SelectRect = true;
            }
            else MapSelectRect1.StopAction();
        }
        public void ObjectStatistic()
        {

            FormViewSel = new ViewSelect();

            // если выделяем объекты по клику мыши
            if (SelectClick.Checked)
            {
                for (int g = 1; g <= KeyObj.Count; g++)
                {// добавляем строки в таблицу
                    FormViewSel.SemGridView.Rows.Add();
                }
                for (int n = 0; n <= KeyObj.Count - 1; n++)
                { //выводим значения списка KeyObj - характеристик объектов в таблицу
                    for (int m = 0; m <= 3; m++)
                    {
                        FormViewSel.SemGridView.Rows[n].Cells[m].Value = KeyObj[n][m];
                    }
                }
            }
            else
            {

                MapFind1.Active = true;
                MapFind1.first();
                while (!MapFind1.Eof)
                {//добавляем строки таблицы
                    FormViewSel.SemGridView.Rows.Add();
                    MapFind1.Next();
                }
                MapFind1.first();
                foreach (DataGridViewRow row in FormViewSel.SemGridView.Rows)
                {/*проходим по строкам и добавляем в каждую клетку таблицы 
                  соответствующие значения*/
                    if (!MapFind1.Eof)
                    {
                        row.Cells[0].Value = MapObj1.Key;
                        row.Cells[1].Value = MapObj1.KeyName;
                        //определяем тип локализации
                        string localtype = MapObj1.Local.ToString();
                        switch (localtype)
                        {
                            case "OL_MARK": localtype = "точечный"; break;
                            case "OL_SQUARE": localtype = "площадной"; break;
                            case "OL_LINE": localtype = "линейный"; break;
                            case "OL_TEXT": localtype = "подпись"; break;
                            case "OL_VECTOR": localtype = "векторный"; break;
                        }
                        row.Cells[2].Value = localtype;
                        row.Cells[3].Value = MapObj1.ObjName;
                        MapFind1.Next();
                    }
                }
            }

            FormViewSel.Show();


        }
        private void ObjStatistic_Click(object sender, EventArgs e)
        {
            if (checkobj == true)
            {
                ObjectStatistic();
            }
        }

        private void SemSquare_Click(object sender, EventArgs e)
        {
            // инициализируем форму для отображения характеристик объектов 
            ForSemantic FormSquareSem = new ForSemantic();

            //если выбираем объекты по клику мыши

            if (SelectClick.Checked)
            {
                for (int g = 0; g <= SemantSquare.Count - 1; g++)
                {//добавляем строки в DataGridView, соответствующие количеству объектов
                    FormSquareSem.SquereAnalyzeGrid.Rows.Add();
                    //заполняем первые две ячейки строки значениями номер и тип объекта
                    for (int m = 0; m <= 1; m++)
                    {
                        FormSquareSem.SquereAnalyzeGrid.Rows[g].Cells[m].Value = KeyObj[g][m * 3];
                    }
                    //остальные ячейки заполняем значениями площади, периметра и длины объекта
                    if (SemantSquare[g][0] != 0)
                    {
                        FormSquareSem.SquereAnalyzeGrid.Rows[g].Cells[2].Value = SemantSquare[g][0];
                        FormSquareSem.SquereAnalyzeGrid.Rows[g].Cells[3].Value = SemantSquare[g][1];
                    }
                    else
                    {
                        if (SemantSquare[g][2] > 0)
                            FormSquareSem.SquereAnalyzeGrid.Rows[g].Cells[4].Value = SemantSquare[g][2];
                    }
                    //подсчитываем сумму площадей, периметров, длин
                    SumSquare += SemantSquare[g][0];
                    SumPer += SemantSquare[g][1];
                    SumLength += SemantSquare[g][2];
                }

            }//если выделяем объекты любым другим способом
            else
            {
                MapFind1.Active = true;
                MapFind1.first();
                while (!MapFind1.Eof)
                {//добавляем строки таблицы
                    FormSquareSem.SquereAnalyzeGrid.Rows.Add();
                    MapFind1.Next();
                }
                MapFind1.first();
                foreach (DataGridViewRow row in FormSquareSem.SquereAnalyzeGrid.Rows)
                {/*проходим по строкам и добавляем в каждую клетку таблицы 
                  соответствующие значения*/

                    if (!MapFind1.Eof)
                    {//добавляем в таблицу номер,тип,площадь,периметр,длину объекта
                        row.Cells[0].Value = MapObj1.Key;
                        row.Cells[1].Value = MapObj1.ObjName;
                        if (MapObj1.SquareInMap() != 0)
                        {
                            row.Cells[2].Value = MapObj1.SquareInMap();
                            row.Cells[3].Value = MapObj1.Perimeter;
                        }
                        else
                        {
                            if (MapObj1.Length > 0)
                                row.Cells[4].Value = MapObj1.Length;
                        }
                        MapFind1.Next();
                        //рассчитываем сумму площадей, периметров, длин объектов
                        if (row.Cells[2].Value != null)
                            SumSquare += (double)row.Cells[2].Value;
                        if (row.Cells[3].Value != null)
                            SumPer += (double)row.Cells[3].Value;
                        if (row.Cells[4].Value != null)
                            SumLength += (double)row.Cells[4].Value;
                    }
                }
            }
            //записываем в последнюю строку значение суммарной площади, периметра, длины
            int rowscount = FormSquareSem.SquereAnalyzeGrid.RowCount - 1;
            FormSquareSem.SquereAnalyzeGrid.Rows[rowscount].Cells[0].Value = "Всего:";
            FormSquareSem.SquereAnalyzeGrid.Rows[rowscount].Cells[2].Value = SumSquare;
            FormSquareSem.SquereAnalyzeGrid.Rows[rowscount].Cells[3].Value = SumPer;
            FormSquareSem.SquereAnalyzeGrid.Rows[rowscount].Cells[4].Value = SumLength;
            FormSquareSem.ShowDialog();
            SemSquare.CheckState = CheckState.Unchecked;
        }

        private void SubObject_Click(object sender, EventArgs e)
        {// инициализируем форму для отображения количества подобъектов
            ForSubObj SubObjForm = new ForSubObj();
            if (SelectClick.Checked)
            {
                for (int g = 0; g <= SubObjList.Count - 1; g++)
                {// добавляем строки в DataGridView
                    SubObjForm.SubObjGrid.Rows.Add();

                    for (int m = 0; m <= 1; m++)
                    {//выводим значение номер и тип объекта
                        SubObjForm.SubObjGrid.Rows[g].Cells[m].Value = KeyObj[g][m * 3];
                    }
                    //выводим количество подобъектов в объекте
                    SubObjForm.SubObjGrid.Rows[g].Cells[2].Value = SubObjList[g];
                }
            }
            else
            {//если выделяем другим способом
                MapFind1.Active = true;
                MapFind1.first();
                while (!MapFind1.Eof)
                {//добавляем строки таблицы
                    SubObjForm.SubObjGrid.Rows.Add();
                    MapFind1.Next();
                }
                MapFind1.first();
                foreach (DataGridViewRow row in SubObjForm.SubObjGrid.Rows)
                {/*проходим по строкам и добавляем в каждую клетку таблицы 
                  соответствующие значения*/
                    if (!MapFind1.Eof)
                    {//добавляем в DataGridView значения номер, тип объекта, количество подобъектов
                        row.Cells[0].Value = MapObj1.Key;
                        row.Cells[1].Value = MapObj1.ObjName;
                        row.Cells[2].Value = MapObj1.Metric.SubjectCount;
                        MapFind1.Next();
                        // если существуют подобъекты выделяем соответствующую строку    
                        if ((int)row.Cells[2].Value != 0)
                        {
                            row.DefaultCellStyle.BackColor = Color.GreenYellow;
                        }
                    }
                }
            }
            SubObjForm.ShowDialog();
        }
        public string SetViewObjSemantic(string item)
        {//инициализируем форму для отображения соответствующих значений выбранной семантики
            ForStringSemant StringSemantForm = new ForStringSemant();
            //задаем имя колонки, соответствующей значению выбранной семантики
            StringSemantForm.ViewSemantGrid.Columns[2].HeaderText = item;

            //проходим по каждому объекту и всем его семантикам
            for (int k = 0; k <= GetSemantName.Count - 1; k++)
            {
                for (int p = 0; p <= GetSemantName[k].Count - 1; p++)
                {// если выбранная семантика совпадает с семантикой объекта
                    if (GetSemantName[k][p] == item)
                    {// добавляем строку
                        StringSemantForm.ViewSemantGrid.Rows.Add();
                        //если выбирали объекты по клику мыши
                        if (selectclick)
                        {//в первые две ячейки строки записываем номер и тип соответствующего объекта
                            for (int m = 0; m <= 1; m++)
                            {
                                StringSemantForm.ViewSemantGrid.Rows[rowcount].Cells[m].Value = KeyObj[k][m * 3];
                            }
                            // в оставшуюся ячейку записываем значение выбранной семантики
                            StringSemantForm.ViewSemantGrid.Rows[rowcount].Cells[2].Value = GetSemantValue[k][p];

                        }
                        else
                        {//если объекты были выделены другим способом
                            for (int m = 0; m <= 1; m++)
                            {//в первые две ячейки строки записываем номер и тип соответствующего объекта
                                StringSemantForm.ViewSemantGrid.Rows[rowcount].Cells[m].Value = KeyObj[k][m];
                            }
                            // в оставшуюся ячейку записываем значение выбранной семантики
                            StringSemantForm.ViewSemantGrid.Rows[rowcount].Cells[2].Value = GetSemantValue[k][p];

                        }

                        if (NumerSemanClick == true)
                        {//подсчитываем сумму значений семантик, и добавляем соответствующие значения семантик в список
                            //для дальнейших расчётов
                            SumNumerSemant += Convert.ToDouble(GetSemantValue[k][p], CultureInfo.GetCultureInfo("en-US"));
                            NumSemValue.Add(Convert.ToDouble(GetSemantValue[k][p], CultureInfo.GetCultureInfo("en-US")));
                        }
                        rowcount++;//увеличиваем счетчик строк
                    }
                }
            }
            //рассчитываем для числовой семантики среднее, минимальное и максимальное значения
            if (NumSemValue.Count != 0)
            {
                double AverageValue = NumSemValue.Average();
                double MaxValue = NumSemValue.Max();
                double MinValue = NumSemValue.Min();
                NumSemValue.Clear();
                StringSemantForm.TextBox1.Visible = true;
                //выводим в TextBox сумму, среднее, максимальное и минимальное значения
                StringSemantForm.TextBox1.Text = "Всего: " + SumNumerSemant.ToString() + Environment.NewLine +
                "Среднее: " + AverageValue.ToString() + Environment.NewLine + "Максимум: " + MaxValue +
                 Environment.NewLine + "Минимум: " + MinValue;
            }


            StringSemantForm.ShowDialog();
            return "";
        }

        private void GetSemantic_Click(object sender, EventArgs e)
        { //инициализируем форму списка уникальных семантик выделенных объектов
            SelectSemantic SemantList = new SelectSemantic();
            NumerSemanClick = false;
            //выбор объектов любым способом, кроме по клику мыши
            if (SelectClick.Checked == false)
            {
                MapFind1.Active = true;
                MapFind1.first();
                while (!MapFind1.Eof)
                {  //инициализируем списки для хранения семантики объекта и соответствующего значения объекта
                    GetSemantName.Add(new List<string>());
                    GetSemantValue.Add(new List<string>());
                    KeyObj.Add(new List<string>());
                    KeyObj[i].Add(MapObj1.Key.ToString());
                    KeyObj[i].Add(MapObj1.ObjName);

                    for (int j = 1; j <= MapObj1.Semantic.SemanticCount; j++)
                    {//добавляем в списки имя семантики и ее значение          
                        GetSemantName_1.Add(MapObj1.Semantic.SemanticName_get(j));
                        GetSemantName[i].Add(MapObj1.Semantic.SemanticName_get(j));
                        GetSemantValue[i].Add(MapObj1.Semantic.SemanticValue_get(j));
                    }
                    i++;
                    MapFind1.Next();

                }

                //определяем уникальные семантики
                UnikeSemant = GetSemantName_1.Distinct().ToList();
            }
            if (UnikeSemant.Count != 0)
            {
                for (int i = 0; i <= UnikeSemant.Count - 1; i++)
                {//добавляем уникальные семантики в список с возможностью выбора
                    SemantList.SemanticListBox.Items.Add(UnikeSemant[i]);
                }
                SemantList.ShowDialog();
            }
            else MessageBox.Show("Выбранные объекты не содержат семантик!");

        }

        private void SelectNumericSemant_Click(object sender, EventArgs e)
        {//инициализируем форму для выбора семантики
            SelectSemantic SemantList = new SelectSemantic();
            NumerSemanClick = true;//устанавливаем флаг нажатия на кнопку анализ числовой семантики
            if (SelectClick.Checked == false)
            {
                MapFind1.Active = true;
                MapFind1.first();
                while (!MapFind1.Eof)
                {//инициализируем списки для хранения семантики объекта и соответствующего значения объекта
                    GetSemantName.Add(new List<string>());
                    GetSemantValue.Add(new List<string>());
                    KeyObj.Add(new List<string>());
                    KeyObj[i].Add(MapObj1.Key.ToString());
                    KeyObj[i].Add(MapObj1.ObjName);
                    for (int j = 1; j <= MapObj1.Semantic.SemanticCount; j++)
                    { //добавляем в списки соответствующие значения имени семантик и их значение
                        GetSemantName_1.Add(MapObj1.Semantic.SemanticName_get(j));
                        GetSemantName[i].Add(MapObj1.Semantic.SemanticName_get(j));
                        GetSemantValue[i].Add(MapObj1.Semantic.SemanticValue_get(j));
                    }
                    i++;
                    MapFind1.Next();
                }
                //определяем уникальные семантики
                UnikNumerSem = GetSemantName_1.Distinct().ToList();

            }
            // проходим по списку уникальных семантик
            for (int t = 0; t <= UnikNumerSem.Count - 1; t++)
            {//добавляем в соответствующие списки SemantCode-код семантики, 
                //TypeSemant-тип семантики 
                SemantCode.Add(MapView1.MapSemantics.SemanticCodeName_get(UnikNumerSem[t]));
                TypeSemant.Add(MapView1.MapSemantics.TypeByCode_get(SemantCode[t]));
                //если семантика не числовая-заполняем соответствующие строки пробелами
                if (TypeSemant[t] != 1)
                {
                    UnikNumerSem[t] = " ";
                }
            }
            //удаляем неподходящие семантики
            for (int h = 0; h <= UnikNumerSem.Count - 1; h++)
            {
                if (UnikNumerSem[h] == " ")
                {
                    UnikNumerSem.RemoveAt(h);
                    h = -1;
                }
            }
            if (UnikNumerSem.Count != 0)
            {
                for (int i = 0; i <= UnikNumerSem.Count - 1; i++)
                {// заполняем список семантик для выбора, числовыми семантиками

                    SemantList.SemanticListBox.Items.Add(UnikNumerSem[i]);
                }
                SemantList.ShowDialog();
            }
            else MessageBox.Show("Выбранные объекты не содержат семантик!");

        }

        public void MapEditMetric1_OnStopAction(object sender, EventArgs e)
        {
            if (MoveSetObj) return;
            if (CutObj.Checked)
            {
                MapEditMetric1.StopAction();
                cutobjcount = 3;
                NewObj = false;
                return;
            }
            MapObj1.Style = axGisToolKit.TxObjectStyle.OS_NORMAL;
            //освобождаем идентификатор объекта карты
          
            MapObj1.ObjHandle = 0;
            
            NewObj = false;
            CreateObj.CheckState = CheckState.Unchecked;
        }

        private void MapEditMetric1_OnExecute(object sender, EventArgs e)
        {
            if (MoveSetObj) return;
            //сбрасываем выделение объекта
            MapObj1.Style = axGisToolKit.TxObjectStyle.OS_NORMAL;
            //записать объект в базу данных и перерисовать его
            if (CreateObjByType.Checked)
                // записать объект в карту как новый
                    MapObj1.CommitAsNew(); 
                // переписать сам объект
                else MapObj1.Commit();    
            //перерисовать объект карты
            MapObj1.Repaint();
            MapView1.Repaint();
          
                    
            CreateObjByType.CheckState = CheckState.Unchecked;
            CreateSubObj.CheckState = CheckState.Unchecked;
            AddObjPoint.CheckState = CheckState.Unchecked;
            RemObjPoint.CheckState = CheckState.Unchecked;
            MoveObjPoint.CheckState = CheckState.Unchecked;
            MoveObj.CheckState = CheckState.Unchecked;

        }

        public List<List<string>> get_tag_value( string path)
        {
            //инициализируем класс XML - документ 
            XmlDocument doc = new XmlDocument();
            //загружаем XML-документ из указанного адреса
            try
            {
                doc.Load(path);
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.ToString());
               
            }
            
            //получаем коллекцию дочерних узлов
            XmlNodeList nodeList = doc.DocumentElement.ChildNodes;
            foreach (XmlElement element in nodeList)
            {
              
                    el.Add(new List<string>());
                    //заполняем список значениями атрибутов тега
                    el[i].Add(element.Attributes.GetNamedItem("id").Value.ToString());
                    el[i].Add(element.Attributes.GetNamedItem("type").Value.ToString());
                    el[i].Add(element.Attributes.GetNamedItem("kind").Value.ToString());
                    el[i].Add(element.Attributes.GetNamedItem("text").Value.ToString());
                    XmlNodeList childelement = element.ChildNodes;
                    foreach (XmlNode child in childelement)
                    {//добавляем в список значение тега с координатами
                        el[i].Add(child.InnerText);
                    }
                    i++;
              }
               return el;
        }

        private void Form1_Load(object sender, EventArgs e)
        { //восстанавливаем сохранённые параметры настроек
            if (Properties.Settings.Default.MapFileName.Length > 0)
           if (File.Exists(Properties.Settings.Default.MapFileName))
            {
           MapView1.MapFileName=Properties.Settings.Default.MapFileName;
           MapView1.ViewScale = Properties.Settings.Default.ViewScale;
           MapView1.MapVisible = true;
           MapView1.Refresh();
           MapView1.MapLeft = Properties.Settings.Default.MapLeft;
           MapView1.MapTop = Properties.Settings.Default.MapTop;
           MapView1.PlaceOut = axGisToolKit.TxPPLACE.PP_PICTURE;
           percision = Properties.Settings.Default.Percision;
            }
        }

        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {  //сохраняем параметры приложения
            Properties.Settings.Default.MapFileName = MapView1.MapFileName;
            Properties.Settings.Default.MapLeft = MapView1.MapLeft;
            Properties.Settings.Default.MapTop = MapView1.MapTop;
            Properties.Settings.Default.ViewScale = MapView1.ViewScale;
            Properties.Settings.Default.Percision = percision;
            Properties.Settings.Default.Save();
        }

        private void GetMapPoint1_OnPointSelect(object sender, EventArgs e)
        {
          //определяем номер выбранного подобъекта
          int subobjnumb = GetMapPoint1.PointSubj;
          if (subobjnumb != 0)
           { //удаляем выбранный подобъект
             EditMapObj.mapDeleteSubject(MapObj1.ObjHandle, subobjnumb);
             MapObj1.Commit();
             MapObj1.Repaint();
             NewObj = false; 
            }
            else return; }

     
   
       

        
      

    }
}
